@REM #! /bin/sh
@REM # Test for backreferences and other things.
@REM : ${srcdir=.}
@REM failures=0

@if EXIST grepsetup.bat goto DOSETUP
@if EXIST %TEMPGREP% goto DNSETUP
@goto ERR1
:DOSETUP
@call grepsetup
@if EXIST %TEMPGREP% goto DNSETUP
@goto ERR1

:DNSETUP
@if "%TEMPECH%." == "." goto ERR1
@if "%TEMPFIL%." == "." goto ERR1
@set TEMPERR=0
@set TEMPMEE=0

@REM # checking for a palindrome
@echo radar|%TEMPGREP% -e "\(.\)\(.\).\2\1" >nul 2>&1
@set TEMPERR=%ERRORLEVEL%
@if ERRORLEVEL 1 goto TEST1FAIL
@%TEMPECH% Backref: palindrome, test #1 succeeded, got %TEMPERR%
@goto TEST2
:TEST1FAIL
@REM if test $? -ne 0 ; then
@echo Backref: palindrome, test #1 failed, got %TEMPERR%, expected 0
@echo Backref: palindrome, test #1 failed, got %TEMPERR%, expected 0 >> %TEMPFIL%
@set /a TEMPFAIL+=1
@set /a TEMPMEE+=1
@goto TEST2

:TEST2
@REM # hit hard with the `Bond' tests
@REM # For now, remove the ``?'' in the last parentheses, so that new glibc can do it.  --Stepan
@echo civic|%TEMPGREP% -E -e "^(.?)(.?)(.?)(.?)(.?)(.?)(.?)(.?)(.).?\9\8\7\6\5\4\3\2\1$" >nul 2>&1
@set TEMPERR=%ERRORLEVEL%
@if ERRORLEVEL 1 goto TEST2FAIL
@%TEMPECH% Backref: Bond, test #2 succeeded, got %TEMPERR%
@goto TEST3
:TEST2FAIL
@REM if test $? -ne 0 ; then
@echo Backref: Bond, test #2 failed, got %TEMPERR%, expected 0
@echo Backref: Bond, test #2 failed, got %TEMPERR%, expected 0 >> %TEMPFIL%
@set /a TEMPFAIL+=1
@set /a TEMPMEE+=1
@goto TEST3

:TEST3
@REM # backref are local should be error
@echo 123| %TEMPGREP% -e "a\(.\)" -e "b\1" >nul 2>&1
@REM if test $? -ne 2 ; then
@if ERRORLEVEL 2 goto TEST3OK
@echo Backref: Backref not local, test #3 failed, got %TEMPERR%, expected 2
@echo Backref: Backref not local, test #3 failed, got %TEMPERR%, expected 2 >> %TEMPFIL%
@set /a TEMPFAIL+=1
@set /a TEMPMEE+=1
@goto TEST4
:TEST3OK
@%TEMPECH% Backref: Backref not local, test #3 succeeded, got %TEMPERR%
@goto TEST4


:TEST4
@REM # Pattern should fail
@echo 123|%TEMPGREP% -e "[" -e "]" >nul 2>&1
@set TEMPERR=%ERRORLEVEL%
@if ERRORLEVEL 2 goto TEST4OK
@REM if test $? -ne 2 ; then
@echo Backref: Compiled not local, test #4 failed, got %TEMPERR%, expected 2
@echo Backref: Compiled not local, test #4 failed, got %TEMPERR%, expected 2 >> %TEMPFIL%
@set /a TEMPFAIL+=1
@set /a TEMPMEE+=1
@goto TEST5
:TEST4OK
@%TEMPECH% Backref: Compiled not local, test #4 succeeded, got %TEMPERR%
@goto TEST5

:TEST5
@REM additional tests go here

@if "%TEMPMEE%." == "0." goto ALLOK
@echo Backref: It appears %TEMPMEE% tests failed ...
@goto END
:ALLOK
@echo Backref: It appears ALL tests succeeded ...
@goto END


:ERR1
@echo backref: test not done ...
@goto END


:END
